package ale.org.kie.spring.jbpm.test;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import bitronix.tm.resource.jdbc.PoolingDataSource;

import org.jbpm.process.audit.AuditLogService;
import org.jbpm.process.audit.ProcessInstanceLog;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.api.task.TaskService;
import org.kie.api.task.model.TaskSummary;
import org.kie.internal.runtime.manager.context.ProcessInstanceIdContext;
import org.kie.spring.factorybeans.RuntimeManagerFactoryBean;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import static junit.framework.Assert.*;

public class Reproducer extends AbstractJbpmSpringTest {

    @Test
    public void testSpringWithJTAAndEMF() throws Exception{

        
        RuntimeManager manager = RuntimeManagerHelper.getInstance().getRuntimeManager();

        RuntimeEngine engine = manager.getRuntimeEngine(ProcessInstanceIdContext.get());
        KieSession ksession = engine.getKieSession();
        TaskService taskService = engine.getTaskService();
        
		Map<String, Object> processParams = new HashMap<String, Object>();
		processParams.put("start", true);
		ProcessInstance p1 = ksession.startProcess("com.sample.rewards-basic",processParams);        
        
        System.out.println("Process started");
        
		List<TaskSummary> tasks = taskService.getTasksAssignedAsPotentialOwner("john", "en-UK");
		long taskId = tasks.get(0).getId();
		taskService.start(taskId, "john");
		taskService.complete(taskId, "john", null);
                
        
    }
}